<template>
  <section class="mt-calendar-annuel">
    <section v-for="(mois, index) in donnees" :key="`mois${index}`" class="mt-calendar-annuel-month">
      <h2>
        {{ mois.mois }}
      </h2>
      <section class="mt-calendar-annuel-weeks">
        <article v-for="(day, indexD) in days" :key="`days-${index}-${indexD}`" class="day-of-week">
          {{ day }}
        </article>
        <template v-for="(semaine, indexSemaine) in mois.semaines">
          <article
            v-for="jour in semaine.jours"
            :key="`${mois.mois}-day-${indexSemaine}-${jour.jour}`"
            class="mt-calendar-annuel-day"
          >
            <article class="jour-dispo" :class="{ 'not-in-month': notInMonth(jour, mois) }">
              <div class="day" :class="{ 'mt-today': jour.today }">
                {{ jour.jour }}
              </div>
              <mt-disponibilite-puce
                v-if="isEmploye && jour.disponibilite"
                :type-disponibilite="jour.disponibilite.typeDisponibilite"
                size="0.35rem"
              ></mt-disponibilite-puce>
            </article>
            <template v-for="(positionActivite, indexActivite) in jour.activites">
              <nuxt-link
                v-if="positionActivite.activite"
                :key="`activite${indexActivite}`"
                ref="link"
                :to="
                  profilLink({
                    name: 'activites-id',
                    params: { id: positionActivite.activite.id },
                    query: { visu: 'annuelle' },
                  })
                "
              >
                <article class="mt-calendar-annuel-activite" :class="cssClass(positionActivite, jour, mois)">
                  <mt-mini-popup-activite
                    :activite="positionActivite.activite"
                    :tag-class="typeActiviteClass(positionActivite.activite)"
                  ></mt-mini-popup-activite>
                </article>
              </nuxt-link>
              <article v-else :key="`activite${indexActivite}`" class="mt-calendar-annuel-activite"></article>
            </template>
          </article>
        </template>
      </section>
    </section>
  </section>
</template>

<script>
import { Info } from 'luxon';
import { classResolver } from '~/components/mixins/activityMixin';
import MtMiniPopupActivite from '~/components/calendar/annuel/mini-popup-activite';
import MtDisponibilitePuce from '~/components/disponibilite/disponibilite-puce';

export default {
  name: 'MtCalendarAnnuel',
  components: { MtDisponibilitePuce, MtMiniPopupActivite },
  mixins: [classResolver],
  props: {
    donnees: {
      type: Array,
      default: () => [],
    },
  },
  data() {
    const isEmploye = this.$store.getters['context/isEmploye'];
    return {
      days: Info.weekdays('narrow', { locale: 'fr-CA' }),
      isEmploye,
    };
  },
  methods: {
    typeActiviteClass(activite) {
      const prefix = 'mt-background-type-';
      return [this.resolveTypeActivite(activite, prefix).class];
    },
    cssClass({ debut, fin, activite }, jour, mois) {
      if (!activite || !activite.typeActivite) {
        return '';
      }
      const classes = this.typeActiviteClass(activite);
      if (debut) {
        classes.push('mt-is-start-day');
      }
      if (fin) {
        classes.push('mt-is-end-day');
      }
      if (this.notInMonth(jour, mois)) {
        classes.push('not-in-month');
      }
      return classes;
    },
    notInMonth({ mois }, { numero }) {
      return mois !== numero;
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.mt-calendar-annuel {
  display: grid;
  grid-template-columns: repeat(auto-fill, minmax(260px, 1fr));
  gap: 1rem;
  flex-wrap: wrap;
  margin: 1rem;
  padding-bottom: 1rem;
}
.mt-calendar-annuel-month {
  display: flex;
  flex-direction: column;
  box-shadow: 0 2px 6px 0 #efefef;
  border-radius: 4px;
  padding: 0.5rem 1rem;

  h2 {
    text-align: center;
    text-transform: uppercase;
    font-size: 0.875rem;
    font-weight: bold;
    color: #5f5f5f;
    cursor: default;
  }
}
.mt-calendar-annuel-weeks {
  display: grid;
  grid-template-columns: repeat(7, 1fr);
}
.mt-calendar-annuel-day {
  display: flex;
  flex-direction: column;
  flex-grow: 1;
  text-align: center;
  padding-bottom: 0.25em;
}
.mt-calendar-annuel-day:nth-child(7n - 1) .jour-dispo,
.mt-calendar-annuel-day:nth-child(7n) .jour-dispo {
  opacity: 0.5;

  &.not-in-month {
    opacity: 0.1;
  }
}
.day {
  font-size: 0.875rem;
  color: #5f5f5f;
  cursor: default;
  padding: 0.2em 0.4em 0;
  border-radius: 50%;
  min-width: 1.8em;
  text-align: center;

  &.mt-today {
    color: white;
    background-color: $primary;
  }
}
.jour-dispo {
  align-self: center;
  justify-self: end;

  display: flex;
  position: relative;
  flex-direction: row;
  align-items: center;

  /deep/ .mt-disponibilite-puce {
    position: absolute;
    right: -0.35rem;
  }
}
.mt-calendar-annuel-activite {
  min-height: 4px;
  margin-bottom: 2px;
  font-size: 0.5rem;
  position: relative;

  &:hover {
    .mt-pop-up-activite {
      display: flex;
      flex-direction: column;
      align-items: flex-start;
    }
  }

  &.not-in-month:hover {
    opacity: 1;
  }
}
.day-of-week {
  color: #aeaeae;
  font-size: 0.75rem;
  text-align: center;
  margin: 0.3em 0;
}
.mt-is-start-day {
  border-bottom-left-radius: 4px;
  border-top-left-radius: 4px;
  margin-left: 1px;
}
.mt-is-end-day {
  border-bottom-right-radius: 4px;
  border-top-right-radius: 4px;
  margin-right: 1px;
}
.not-in-month {
  opacity: 0.2;
}
</style>
